const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payments = sequelize.define(
    'payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

payment_method: {
        type: DataTypes.ENUM,
      
      

        values: [

"cash_on_delivery",


"zain_cash",


"card",


"bank_transfer"

        ],

      },

payment_provider: {
        type: DataTypes.ENUM,
      
      

        values: [

"internal",


"zain_cash",


"stripe",


"manual"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"initiated",


"authorized",


"captured",


"failed",


"refunded",


"cancelled"

        ],

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

transaction_reference: {
        type: DataTypes.TEXT,
      
      

      },

provider_payload: {
        type: DataTypes.TEXT,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










































//end loop



    db.payments.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });




    db.payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payments;
};


